diff -c isearch-patched-2013-01-15.el isearch.el
*** isearch-patched-2013-01-15.el	Tue Jan 15 13:54:02 2013
--- isearch.el	Tue Jan 15 13:49:58 2013
***************
*** 605,612 ****
  (defvar isearch-opoint 0)
  ;; The window configuration active at the beginning of the search.
  (defvar isearch-window-configuration nil)
- ;; The line number of point before searching, relative to the line number of `window-start'.
- (defvar isearch-win-pt-line nil)
  
  ;; Flag to indicate a yank occurred, so don't move the cursor.
  (defvar isearch-yank-flag nil)
--- 605,610 ----
***************
*** 829,836 ****
  	isearch-start-hscroll (window-hscroll)
  
  	isearch-opoint (point)
-         isearch-win-pt-line (- (line-number-at-pos)
-                                (line-number-at-pos (window-start)))
  	search-ring-yank-pointer nil
  	isearch-opened-overlays nil
  	isearch-input-method-function input-method-function
--- 827,832 ----
***************
*** 1312,1319 ****
        ;; This calls pop-state function and restores original point.
        (let ((isearch-cmds (last isearch-cmds)))
  	(isearch--set-state (car isearch-cmds)))
!     (goto-char isearch-opoint)
!     (when isearch-win-pt-line (recenter isearch-win-pt-line)))
    (isearch-done t)                      ; Exit isearch..
    (isearch-clean-overlays)
    (signal 'quit nil))                   ; ..and pass on quit signal.
--- 1308,1314 ----
        ;; This calls pop-state function and restores original point.
        (let ((isearch-cmds (last isearch-cmds)))
  	(isearch--set-state (car isearch-cmds)))
!     (goto-char isearch-opoint))
    (isearch-done t)                      ; Exit isearch..
    (isearch-clean-overlays)
    (signal 'quit nil))                   ; ..and pass on quit signal.

Diff finished.  Tue Jan 15 20:54:28 2013
